// CMPSCI 383 - Programming Assignment 1
// Justin Aquadro
// astar.h

#ifndef _ASTAR_H
#define _ASTAR_H

#include <vector>
#include <list>
#include <queue>
#include <stack>
#include <iostream>
#include "3dcube.h"

template <class T>
class AStar
{
public:
    // Constructors
    AStar();
    ~AStar();
    
    // Methods
    void LoadState (T* state);
    void Iterate ();
    
    // Properties
    stack<T*> stateSpace;
    priority_queue<T*, vector<T*>, T> stateQueue;
    
    int total_expantion;
    int total_expantion_nodes;
};

//--- Constructors -------------------------------------------------------------

template <class T>
AStar<T>::AStar ()
{
    total_expantion = 0;
    total_expantion_nodes = 0;
}

template <class T>
AStar<T>::~AStar ()
{
    while ( !stateSpace.empty() )
    {
        T* obj = stateSpace.top();
        stateSpace.pop();
        
        if ( obj != NULL )
        {
            delete obj;
        }
    }
}

//--- Methods ------------------------------------------------------------------

template <class T>
void AStar<T>::LoadState (T* state)
{
    stateSpace = stack<T*>();
    total_expantion = 0;
    total_expantion_nodes = 0;

    state->Cost();
    stateSpace.push( state );
    stateQueue.push( state );
}

template <class T>
void AStar<T>::Iterate ()
{
    T* obj = stateQueue.top();
    stateQueue.pop();
    
    total_expantion++;

    list<T*> slist = obj->GenerateSuccessors();
    typename list<T*>::iterator iter;
    
    for ( iter = slist.begin(); iter != slist.end(); iter++ )
    {
        stateSpace.push( *iter );
        stateQueue.push( *iter );
        
        total_expantion_nodes++;
    }
}
    

#endif
