// CMPSCI 383 - Programming Assignment 1
// Justin Aquadro
// main.cpp

#include "3dcube.h"
#include "astar.h"
#include <string>
#include <iostream>
#include <stack>

using namespace std;

int main ( int argc, char *argv[] )
{
    string harg;
    
    if ( argc <= 1 )
    {
        harg = "-H2";
    }
    else
    {
        harg = argv[1];
        
        if ( harg != (string)"-H1" && harg != (string)"-H2" && harg != (string)"-H3" )
        {
            cout << "Error: Valid heuristics are -H1, -H2, and -H3\n";
            return 0;
        }
        
        harg = argv[1];
    }
    
    string input;
    getline( cin, input );
    
    C3DCube* cube3 = new C3DCube( harg.substr(1) );
    cube3->GenerateFrom(input);

    AStar<C3DCube> as;
    as.LoadState( cube3 );
    while ( !as.stateQueue.top()->GoalTest() )
    {
        as.Iterate();
    }

    C3DCube* goal = as.stateQueue.top();
    stack<C3DCube*> goalPath;
    
    while ( goal->parent != NULL )
    {
        goalPath.push( goal );
        goal = goal->parent;
    }

    goal->PrintBoard();

    while ( !goalPath.empty() )
    {
        goalPath.top()->PrintBoard();
        goalPath.pop();
    }
    
    return 0;
}
