// -*- C++ -*-

#ifndef _GCSTACK_H_
#define _GCSTACK_H_

#include "../mmapwrapper.h"
#include "dynstack.h"

/// Small object to denote a region of memory
struct GC_ms_entry {
	void * address;
	size_t length;
};

typedef GC_ms_entry GC_mse;

/// Singleton stack that can be accessed at all tiers of the heap hierarchy,
/// allows miniheaps to add additional memory regions to be scanned.
class GCStack : public DynamicStack<GC_mse> {
public:
	
	static GCStack* getStack (void) {
		if (_instance == 0) {
			_instance = (GCStack*) MmapWrapper::map (sizeof(GCStack));
			_instance = new (_instance) GCStack;
		}
		
		return _instance;
	}
	
protected:
	
	GCStack ()
		{ }
		
	~GCStack ()
		{ }
	
private:

	static GCStack* _instance;
	
};

GCStack* GCStack::_instance = 0;

#endif
