#ifndef _ONEHEAP_H_
#define _ONEHEAP_H_

template <class TheHeap>
class OneHeap {
public:

  static inline void * malloc (size_t sz) {
    return getHeap().malloc (sz);
  }

  static inline bool free (void * ptr) {
    return getHeap().free (ptr);
  }

  static inline size_t getSize (void * ptr) {
    return getHeap().getSize (ptr);
  }
  
  /// +++
  static inline int markScan (void * ptr) {
  	return getHeap().markScan (ptr);
  }
  
  static inline void gcZeroBitmaps (void) {
  	getHeap().zeroBitmaps();
  }
  
  static inline void gcSweep (void) {
  	getHeap().sweep();
  }
  
  static inline size_t gcLiveSize (void) {
  	return getHeap().gcLiveSize();
  }

protected:

  static inline TheHeap& getHeap (void) {
    static TheHeap _heap;
    return _heap;
  }

};


#endif
